#ifndef SENSE_API_PROVIDER_DESC_H
#define SENSE_API_PROVIDER_DESC_H

#include <string>
#include <memory>
#include <atomic>
#include <vector>
#include <dlfcn.h>
#include <functional>
#include <user/senseApiDesc.h>
#include <spinscale/qutex.h>

namespace smo {
namespace stim_buff {

class StimBuffApiLib
{
private:
	friend class StimBuffApiManager;
	struct DlCloser
	{
		void operator()(void* handle) const
		{
			if (handle) {
				dlclose(handle);
			}
		}
	};

public:
	StimBuffApiLib(
		const std::string& path, void *_dlopen_handle,
		SMO_GET_STIM_BUFF_API_DESC_FN_TYPEDEF *descFn)
	: libraryPath(path), qutex("StimBuffApiLib-" + path),
	isBeingDestroyed(false),
	dlopen_handle(_dlopen_handle, DlCloser()),
	SMO_GET_STIM_BUFF_API_DESC_FN_NAME(descFn)
	{}

	void setStimBuffApiDesc(const StimBuffApiDesc &desc)
	{
		if (!StimBuffApiDesc::sanityCheck(desc))
		{
			throw std::runtime_error(
				std::string(__func__) + ": Sanity check failed for stim buff API "
				"descriptor in library '" + libraryPath + "'");
		}

		stimBuffApiDesc = desc;
	}

public:
	std::string libraryPath;
	sscl::Qutex qutex;
	std::atomic<bool> isBeingDestroyed;
	std::unique_ptr<void, DlCloser> dlopen_handle;
	/* UNIMPLEMENTED: API-specific cmdline options. These affect this specific
	 * stim buff api lib's behaviour globally.
	 */
	std::vector<std::string> options;

	/**
	 * @brief Each stim buff API library must provide a function returning a
	 * StimBuffApiDesc. This struct specifies which API the library uses to
	 * connect Salmanoff to its supported stim buff provider.
	 *
	 * This getter function should be visible to dlsym() so that Salmanoff can
	 * find it in the lib after loading it, and call it.
	 */
	std::function<SMO_GET_STIM_BUFF_API_DESC_FN_TYPEDEF>
		SMO_GET_STIM_BUFF_API_DESC_FN_NAME;

	/**
	 * @brief Salmanoff will call the `SMO_GET_STIM_BUFF_API_DESC_FN_NAME` getter
	 * function and use the data it provides in order to fill out this
	 * descriptor.
	 */
	StimBuffApiDesc stimBuffApiDesc;

	std::string stringify() const {
		std::string result = "Library Path: " + libraryPath + "\n";
		result += "Stim Buff API Descriptor: " + stimBuffApiDesc.stringify() + "\n";
		return result;
	}
};

} // namespace stim_buff
} // namespace smo

#endif // SENSE_API_PROVIDER_DESC_H
